function varargout = mouth_gui(varargin)

% MOUTH_GUI M-file for mouth_gui.fig
%      MOUTH_GUI, by itself, creates a new MOUTH_GUI or raises the existing
%      singleton*.
%
%      H = MOUTH_GUI returns the handle to a new MOUTH_GUI or the handle to
%      the existing singleton*.
%
%      MOUTH_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MOUTH_GUI.M with the given input arguments.
%
%      MOUTH_GUI('Property','Value',...) creates a new MOUTH_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mouth_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mouth_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mouth_gui

% Last Modified by GUIDE v2.5 15-Jul-2008 13:07:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @mouth_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @mouth_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mouth_gui is made visible.
function mouth_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to mouth_gui (see VARARGIN)

% Choose default command line output for mouth_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes mouth_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = mouth_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
happy=imread('happy_logo.bmp');
neutral=imread('neutral_logo.bmp');
sad=imread('sad_logo.bmp');
mouth=handles.mouth;
features=shape_features(mouth);
[expression]=find_expression(features);
axes(handles.axes3);
if expression==1
    imshow(sad);
else if expression==2
         imshow(happy);
    else
         imshow(neutral);
    end
end
% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[imageFilename,imagePath] = uigetfile({'*','images ';'*.*','All files (*.*)'},'Open Image','MultiSelect','off');
im=imread([imagePath, imageFilename]);
axes(handles.axes1)
imshow(im)

%crop mouth from face image
figure; imshow(im)
[imc, rect]=imcrop(im);
[mouth]=mouth_segmentation_for_gui(imc);

%display mouth image boundary on gui surface
axes(handles.axes1)
imshow(im);
hold on
[B,L] = bwboundaries(mouth,'noholes');

for k = 1:length(B)
    boundary = B{k};
    plot(boundary(:,2)+rect(1), boundary(:,1)+rect(2), 'r', 'LineWidth', 2)
end

handles.mouth=mouth;
% save data
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function axes1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes1


% --- Executes during object creation, after setting all properties.
function axes3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes3


