% project 10 / vienna/ july 2008
% mouth segmentation function

function [mouth]=mouth_segmentation(im)

%transform to hsv and obtain hue matrix
imhsv=rgb2hsv(im);
h=imhsv(:,:,1);
[x,y]=size(h);

%shift hue matrix to join edges deformed by wrapping
for i=1:x*y
    if h(i)<0.5
        h(i)=h(i)+1;
    end
end
h=h-0.5;
%threshold hue
th=graythresh(h);
bw=abs(1-im2bw(h,th));

%morphological operations 
se=strel('disk',5);
bw=imopen(bw,se);

%find boundaries and keep the longest one (expected to correspond to mouth)
boundim=zeros(x,y);
  [Ba,L,N,A] = bwboundaries(bw,'noholes');
  Big=Ba{1};
  for k=2:N
       if size(Ba{k},1)>size(Big,1)
           size(Ba{k},1);
           Big=Ba{k};
       end      
  end

  boundim=zeros(x,y);
  for k = 1:length(Big)
        boundary = Big(k,:);
        if (boundary(1)>1 && boundary(2)>1)
            boundim(boundary(1)-1:boundary(1), boundary(2)-1:boundary(2))=1;
        end             
  end
  
%morphological operations
mouth=imfill(boundim);
se=strel('disk',5);
mouth=imclose(mouth,se);
mouth=imfill(mouth);


end
     
